1 'Standardless program for microanalysis in SEM or EPMA
4 'Author:Henrik Kaker,Nov-1987
6  CLEAR
8  KEY OFF
21 color 7,0,0:CLS
22 DIM O(16),P(16),Q(16),R(16),S(16),U(16),V(16),W(16),X(16),Y(16),C0(16),A(16)
23 DIM Z$(16),T$(16),N(16),Z(16),T(16),F(16),H(16),E(16),K(16),G(16),YY(16)
24 DIM M(16,16),C(16),D(16),B(16),GG(16),XX(16),A5(16),A6(16),L(16)
25 T$="Quantitative Standardless Analysis"
26 locate 5,(80-len(t$))/2:Print T$
27 'spectrometer type
28 locate 9,22
29 input"File name (without *.dat) : ",f$
34 'file transformation
36 OPEN"i",#1,f$+".dat"
37 I=0
38 WHILE NOT EOF(1)
39 INPUT #1,A$
40 I=I+1
41 WEND
42 CLOSE #1
43 OPEN"i",#2,f$+".dat"
44 OPEN"o",#3,"data.dat"
45 I=0
46 WHILE NOT EOF(2)
47 INPUT #2,A$
48 IF I>=5 THEN PRINT #3,A$
49 I=I+1
50 WEND
51 CLOSE
52 OPEN"i",#4,"data.dat"
53 N=0
54 WHILE NOT EOF(4)
55 INPUT #4,A$
56 N=N+1
57 WEND
58 CLOSE #4
59 OPEN"i",#5,"data.dat"
60 OPEN"o",#6,"elem.dat"
61 FOR I=1 TO N
62 INPUT #5,A$
63 A$=LEFT$(A$,2)
64 PRINT #6,A$
65 NEXT I
66 CLOSE
67 OPEN"i",#7,"data.dat"
68 OPEN"o",#8,"line.dat"
69 FOR I=1 TO N
70 INPUT #7,A$
71 A$=LEFT$(A$,6)
72 B$=RIGHT$(A$,3)
73 PRINT #8,B$
74 NEXT I
75 CLOSE
76 OPEN"i",#9,"data.dat"
77 OPEN"o",#10,"cps.dat"
78 FOR I=1 TO N
79 INPUT #9,A$
80 A$=RIGHT$(A$,15)
81 PRINT #10,A$
82 NEXT I
83 CLOSE
90 LOCATE 13,20
95 INPUT"Spectrometer type (EDS/WDS) : ",A$
100 IF A$="E" OR A$="e" OR A$="W" OR A$="w" GOTO 110 ELSE 90
110 OPEN"i",#2,"Cond.dat"
112 INPUT #2,E0
113 INPUT #2,XY99
114 INPUT #2,YX99
116 INPUT #2,YZX99
118 CLOSE #2
120 OPEN"i",#3,"elem.dat"
130 A=0
140 WHILE NOT EOF(3)
142 INPUT #3,Z$(N1)
144 A=A+1
145 WEND:CLOSE #3
146 LOCATE 17,22
147 INPUT" Elements or oxides (e/o) : ",UU$
150 OPEN"i",#4,"elem.dat"
152 OPEN"i",#5,"line.dat"
154 OPEN"i",#6,"cps.dat"
155 CLS
160 FOR I=1 TO A
170 INPUT #4,Z$(I)
171 IF Z$(I)="C" THEN Z(I)=6
172 IF Z$(I)="N" THEN Z(I)=7
173 IF Z$(I)="O" THEN Z(I)=8
174 IF Z$(I)="F" THEN Z(I)=9
175 IF Z$(I)="NA" THEN Z(I)=11
176 IF Z$(I)="MG" THEN Z(I)=12
177 IF Z$(I)="AL" THEN Z(I)=13
178 IF Z$(I)="SI" THEN Z(I)=14
179 IF Z$(I)="P" THEN Z(I)=15
180 IF Z$(I)="S" THEN Z(I)=16
181 IF Z$(I)="CL" THEN Z(I)=17
182 IF Z$(I)="K" THEN Z(I)=19
183 IF Z$(I)="CA" THEN Z(I)=20
184 IF Z$(I)="SC" THEN Z(I)=21
185 IF Z$(I)="TI" THEN Z(I)=22
186 IF Z$(I)="V" THEN Z(I)=23
187 IF Z$(I)="CR" THEN Z(I)=24
188 IF Z$(I)="MN" THEN Z(I)=25
189 IF Z$(I)="FE" THEN Z(I)=26
190 IF Z$(I)="CO" THEN Z(I)=27
191 IF Z$(I)="NI" THEN Z(I)=28
192 IF Z$(I)="CU" THEN Z(I)=29
193 IF Z$(I)="ZN" THEN Z(I)=30
194 IF Z$(I)="GA" THEN Z(I)=31
195 IF Z$(I)="GE" THEN Z(I)=32
196 IF Z$(I)="AS" THEN Z(I)=33
197 IF Z$(I)="SE" THEN Z(I)=34
198 IF Z$(I)="BR" THEN Z(I)=35
199 IF Z$(I)="RB" THEN Z(I)=37
200 IF Z$(I)="SR" THEN Z(I)=38
201 IF Z$(I)="Y" THEN Z(I)=39
202 IF Z$(I)="ZR" THEN Z(I)=40
203 IF Z$(I)="NB" THEN Z(I)=41
204 IF Z$(I)="MO" THEN Z(I)=42
205 IF Z$(I)="TC" THEN Z(I)=43
206 IF Z$(I)="RU" THEN Z(I)=44
207 IF Z$(I)="RH" THEN Z(I)=45
208 IF Z$(I)="PD" THEN Z(I)=46
209 IF Z$(I)="AG" THEN Z(I)=47
210 IF Z$(I)="CD" THEN Z(I)=48
211 IF Z$(I)="IN" THEN Z(I)=49
212 IF Z$(I)="SN" THEN Z(I)=50
213 IF Z$(I)="SB" THEN Z(I)=51
214 IF Z$(I)="TE" THEN Z(I)=52
215 IF Z$(I)="I" THEN Z(I)=53
216 IF Z$(I)="CS" THEN Z(I)=55
217 IF Z$(I)="BA" THEN Z(I)=56
218 IF Z$(I)="LA" THEN Z(I)=57
219 IF Z$(I)="CE" THEN Z(I)=58
220 IF Z$(I)="PR" THEN Z(I)=59
221 IF Z$(I)="ND" THEN Z(I)=60
222 IF Z$(I)="PM" THEN Z(I)=61
223 IF Z$(I)="SM" THEN Z(I)=62
224 IF Z$(I)="EU" THEN Z(I)=63
225 IF Z$(I)="GD" THEN Z(I)=64
226 IF Z$(I)="TB" THEN Z(I)=65
227 IF Z$(I)="DY" THEN Z(I)=66
228 IF Z$(I)="HO" THEN Z(I)=67
229 IF Z$(I)="ER" THEN Z(I)=68
230 IF Z$(I)="TM" THEN Z(I)=69
231 IF Z$(I)="YB" THEN Z(I)=70
232 IF Z$(I)="LU" THEN Z(I)=71
233 IF Z$(I)="HF" THEN Z(I)=72
234 IF Z$(I)="TA" THEN Z(I)=73
235 IF Z$(I)="W" THEN Z(I)=74
236 IF Z$(I)="RE" THEN Z(I)=75
237 IF Z$(I)="OS" THEN Z(I)=76
238 IF Z$(I)="IR" THEN Z(I)=77
239 IF Z$(I)="PT" THEN Z(I)=78
240 IF Z$(I)="AU" THEN Z(I)=79
241 IF Z$(I)="HG" THEN Z(I)=80
242 IF Z$(I)="TL" THEN Z(I)=81
243 IF Z$(I)="PB" THEN Z(I)=82
244 IF Z$(I)="BI" THEN Z(I)=83
245 IF Z$(I)="U" THEN Z(I)=92
250 INPUT #6,N(I)
260 INPUT #5,T$(I)
270 LOCATE 19,18
290 IF T$(I)="K  " THEN T(I)=1
300 IF T$(I)="L  " THEN T(I)=3
301 IF UU$="O" OR UU$="o" GOTO 302 ELSE 340
302 LOCATE 3,18
303 PRINT TAB(18)"Element";TAB(28)"Line";TAB(38)"Int";TAB(48)"Stehiom.ratio"
304 LOCATE (4+I),21:PRINT Z$(I)
305 LOCATE (4+I),29:PRINT T$(I)
306 LOCATE (4+I),34:PRINT USING"######.###";N(I)
307 LOCATE (4+I),53:INPUT"",A6(I)
340 NEXT I
342 FOR J=1 TO A
344 I=Z(J)
350 'fluoresence yields
360 IF T(J)>2 THEN 390
370 F(J)=.08502-.01548*I+.0005677*I^2+3.174E-05*I^3-6.559E-07*I^4
380 GOTO 400
390 F(J)=-1.983+.1432*I-.003842*I^2+4.578E-05*I^3-1.959E-07*I^4
400 'transition probability
410 IF T(J)>2 THEN 480
420 H=1.052-.000439*I^2
430 IF I<20 THEN 500
440 H=.896-.0006575*I
450 IF I<30 THEN 500
460 H=1.0366-.00682*I+4.815E-05*I^2
470 GOTO 500
480 H=.944
490 IF I>44 THEN H=.4461+.05493*I-.0007717*I^2+3.525E-06*I^3
500 P(J)=H
510 'atomic weights
520 W(J)=-1.42+1.97*I+.0103*I^2-.0000429*I^3
530 REM-X-RAY ENERGY
540 IF T(J)=1 THEN X(J)=-.06654-8.608999E-03*I+.00963*I^2+7.268E-06*I^3+1.131E-07*I^4
550 IF T(J)=3 THEN X(J)=.04776-.01706*I+.001523*I^2+4.414E-06*I^3-1.739E-08*I^4
560 'efficiency
570 E(J)=1
580 I=X(J)
590 IF A$="E" OR A$="e" THEN 610
600 IF X(J)<=3.65 THEN 660
605 IF X(J)>=3.65 THEN 640
610 IF X(J)<2.5 THEN E(J)=(-33.333+95*I-16.6667*I^2)/100
620 IF X(J)>15 THEN E(J)=(110+.3333*I-.0667*I^2)/100
630 GOTO 670
640 E(J)=EXP(-13.283+10.753*LOG(I)-1.909*LOG(I)^2)
650 GOTO 670
660 E(J)=EXP(-6.677+21.887*LOG(I)-28.533*LOG(I)^2+12.453*LOG(I)^3)
670 'shell electrons
680 B(J)=2
690 IF T(J)>2 THEN B(J)=8
700 REM-IONIZATION POTENTIAL
710 Q(J)=.0135*Z(J)
720 'weights
730 G(J)=.35
740 IF T(J)>2 THEN G(J)=.25
750 'critical excitation energies
760 I=Z(J)
770 H=.1304-.002633*I+.009781*I^2+4.144E-05*I^3
780 IF T(J)=1 THEN 800
790 H=.339-.04931*I+.002336*I^2+1.836E-06*I^3
800 K(J)=H
810 NEXT J
820 'mass absorption coefficients
830 FOR I=1 TO A
840 FOR J=1 TO A
850 H=.1304-.002633*Z(I)+.009781*Z(I)^2+4.144E-05*Z(I)^3
860 IF X(J)<H THEN 900
870 D0=5.956+.392*Z(I)-.0105*Z(I)^2+.000152*Z(I)^3-8.51E-07*Z(I)^4
880 M(I,J)=EXP(-2.685*LOG(X(J))+D0)
890 GOTO 1320
900 H=.4506+.01566*Z(I)+.0007599*Z(I)^2+1.792E-05*Z(I)^3
910 IF X(J)<H THEN 950
920 D0=3.257+.3936*Z(I)-.008483*Z(I)^2+9.491E-05*Z(I)^3-4.058E-07*Z(I)^4
930 M(I,J)=EXP(-2.669*LOG(X(J))+D0)
940 GOTO 1320
950 H=-.6018+.01964*Z(I)+.0005935*Z(I)^2+1.843E-05*Z(I)^3
960 IF X(J)<H THEN 1000
970 D0=3.257+.3936*Z(I)-.008483*Z(I)^2+9.491E-05*Z(I)^3-4.058E-07*Z(I)^4
980 M(I,J)=EXP(-2.669*LOG(X(J))+D0)/1.16
990 GOTO 1320
1000 H=.339-.04931*Z(I)+.002336*Z(I)^2+1.836E-06*Z(I)^3
1010 IF X(J)<H THEN 1050
1020 D0=3.257+.3936*Z(I)-.008483*Z(I)^2+9.491E-05*Z(I)^3-4.058E-07*Z(I)^4
1030 M(I,J)=EXP(-2.669*LOG(X(J))+D0)/(1.16*1.41)
1040 GOTO 1320
1050 H=-8.645001+.3977*Z(I)-.005963*Z(I)^2+3.624E-05*Z(I)^3
1060 IF X(J)<H THEN 1100
1070 D0=2.382+.2212*Z(I)-.002028*Z(I)^2+6.891E-06*Z(I)^3
1080 M(I,J)=EXP(-2.514*LOG(X(J))+D0)
1090 GOTO 1320
1100 H=-7.499+.3459*Z(I)-.00525*Z(I)^2+3.263E-05*Z(I)^3
1110 IF X(J)<H THEN 1150
1120 D0=2.382+.2212*Z(I)-.002028*Z(I)^2+6.891E-06*Z(I)^3
1130 M(I,J)=EXP(-2.154*LOG(X(J))+D0)/1.07
1140 GOTO 1320
1150 H=-6.28+.2831*Z(I)-.004117*Z(I)^2+2.505E-05*Z(I)^3
1160 IF X(J)<H THEN 1200
1170 D0=2.382+.2212*Z(I)-.002028*Z(I)^2+6.891E-06*Z(I)^3
1180 M(I,J)=EXP(-2.514*LOG(X(J))+D0)/(1.07*1.11)
1190 GOTO 1320
1200 H=-4.778+.2184*Z(I)-.003303*Z(I)^2+2.115E-05*Z(I)^3
1210 IF X(J)<H THEN 1250
1220 D0=2.382+.2212*Z(I)-.002028*Z(I)^2+6.891E-06*Z(I)^3
1230 M(I,J)=EXP(-2.514*LOG(X(J))+D0)/(1.07*1.11*1.32)
1240 GOTO 1320
1250 H=-2.421+.1172*Z(I)-.001845*Z(I)^2+1.397E-05*Z(I)^3
1260 IF X(J)<H THEN 1300
1270 D0=2.382+.2212*Z(I)-.002028*Z(I)^2+6.891E-06*Z(I)^3
1280 M(I,J)=EXP(-2.514*LOG(X(J))+D0)/(1.07*1.11*1.32*1.44)
1290 GOTO 1320
1300 D0=4.838+.04911*Z(I)
1310 M(I,J)=EXP(-2.451*LOG(X(J))+D0)
1320 NEXT J
1330 NEXT I
1340 'starting conditions
1350 S0=0
1360 FOR I=1 TO A
1370 C(I)=W(I)*N(I)/(F(I)*P(I)*E(I))
1380 S0=S0+C(I)
1390 NEXT I
1400 FOR I=1 TO A
1410 C(I)=C(I)/S0
1420 NEXT I
1430 'iteration
1440 FOR I=1 TO A
1450 U(I)=0
1460 FOR J=1 TO A
1470 U(I)=U(I)+C(J)*M(J,I)
1480 NEXT J
1490 U(I)=2.366*U(I)
1500 NEXT I
1510 FOR I=1 TO A
1520 C0(I)=C(I)
1530 NEXT I
1540 'mean ionization potential
1550 R=0
1560 R0=0
1570 FOR I=1 TO A
1580 R0=R0+C(I)*Z(I)/W(I)
1590 R=R+C(I)*Z(I)/W(I)*LOG(Q(I))
1600 NEXT I
1610 'stopping power factor
1620 FOR I=1 TO A
1630 U0=E0/K(I)
1640 L9=.0000118/SQR(EXP(R/R0))*2
1650 M9=1.47E-06/EXP(R/R0)
1660 S(I)=L9*(-SQR(E0)*LOG(U0)-2*SQR(K(I))+2*SQR(E0))+M9*(E0-K(I)-E0*LOG(U0))
1670 S(I)=S(I)*1/K(I)*B(I)*G(I)/R0*(-1*EXP(R/R0))
1680 S(I)=ABS(S(I))
1690 NEXT I
1700 'backscatter coefficient
1710 FOR I=1 TO A
1720 U1=.1382-.9211/SQR(Z(I))
1730 U2=.1904-.2236*LOG(Z(I))+.1292*LOG(Z(I))^2-.0149*LOG(Z(I))^3
1740 V(I)=E0^U1*U2
1750 NEXT I
1760 'absorption factor
1770 N0=0
1780 FOR I=1 TO A
1790 N0=N0+C(I)*V(I)
1800 NEXT I
1810 FOR I=1 TO A
1820 U0=LOG(E0/K(I))
1830 U1=.49269-1.0987*N0+.78557*N0^2
1840 U2=.70256-1.09865*N0+1.0046*N0^2
1850 Y(I)=U1*U0/(U2+U0)
1860 U3=7.870001E-06*SQR(EXP(R/R0))*E0^1.5+7.35E-07*E0^2
1870 U3=U3/R0
1880 Y(I)=Y(I)*U3
1890 O(I)=(1-EXP(-2*U(I)*Y(I)))/(2*U(I)*Y(I))
1900 D(I)=1
1910 NEXT I
1920 'edge jumps
1930 FOR J1=1 TO A
1940 L(J1)=17.74-.6608*Z(J1)+.01427*Z(J1)^2-.00011*Z(J1)^3
1950 IF T(J1)>2 THEN L(J1)=20.03-.7732*Z(J1)+.01159*Z(J1)^2-5.835E-05*Z(J1)^3
1960 D(J1)=0
1970 'fluorescence factor
1980 FOR J2=1 TO A
1990 IF J2=J1 THEN 2110
2000 IF X(J2)<K(J1) OR (X(J2)-5)>K(J1) THEN 2110
2010 IF T(J2)=T(J1) THEN Y9=1
2020 IF T(J2)>T(J1) THEN Y9=.24
2030 IF T(J1)>T(J2) THEN Y9=4.76
2040 U9=U(J1)/(U(J2)/2.366)
2050 V9=330000!/((E0^1.65-K(J1)^1.65)*(U(J2)/2.366))
2060 Y0=.5*((L(J1)-1)/L(J1)*F(J2)*W(J1)/W(J2))
2070 Y1=((E0/K(J2)-1)/(E0/K(J1)-1))^1.67
2080 Y2=M(J1,J2)/(U(J1)/2.366)
2090 Y3=LOG(1+U9)/U9+LOG(1+V9)/V9
2100 D(J1)=D(J1)+C(J2)*Y0*Y1*Y2*Y3*Y9
2110 NEXT J2
2120 D(J1)=1/(1+D(J1))
2130 NEXT J1
2140 'concentrations
2150 H=0
2160 FOR I=1 TO A
2170 C(I)=N(I)*D(I)*W(I)/(F(I)*P(I)*E(I)*S(I)*O(I))
2180 H=H+C(I)
2190 NEXT I
2200 FOR I=1 TO A
2210 C(I)=C(I)/H
2220 NEXT I
2230 C1=0
2240 'ending conditions
2250 FOR I=1 TO A
2260 IF C(I)-C0(I)>.00001 THEN C1=1
2270 NEXT I
2280 IF C1=1 THEN 1430
2282 FOR I=1 TO A
2284 GG(I)=(C(I)*100)/W(I)
2286 NEXT I
2288 ZZ=0
2290 FOR I=1 TO A
2292 ZZ=ZZ+GG(I)
2294 NEXT I
2295 FOR I=1 TO A
2296 XX(I)=(C(I)*100)*(W(I)+A6(I)*15.9994)/W(I)
2297 NEXT I
2298 PP=O
2299 FOR I=1 TO A
2300 PP=PP+XX(I)
2301 NEXT I
2302 FOR I=1 TO A
2303 YY(I)=XX(I)*100/PP:NEXT I
2304 CLS:LOCATE 3,10
2305 IF UU$="E" OR UU$="e" GOTO 2310 ELSE 2390
2310 LOCATE 3,10
2320 PRINT TAB(8)"Element";TAB(19)"Line";TAB(30)"Int";TAB(41)"Weight percent";TAB(59)"Atomic percent"
2330 FOR I=1 TO A
2340 LOCATE (5+I),10:PRINT"";Z$(I);TAB(20);T$(I);TAB(24);
2342 PRINT USING"######.###";N(I);
2344 PRINT TAB(44);
2350 PRINT USING"###.###";C(I)*100
2360 LOCATE (5+I),62:PRINT USING"###.###";(GG(I)*100)/ZZ
2370 NEXT I
2380 GOTO 2450
2390 CLS:LOCATE 3,10
2400 PRINT TAB(8)"Element";TAB(19)"Line";TAB(30)"Int";TAB(41)"Weight percent";TAB(59)"Weight percent oxide"
2405 FOR I=1 TO A
2410 LOCATE (5+I),10:PRINT"";Z$(I);TAB(20);T$(I);TAB(25);
2412 PRINT USING"######.###";N(I);
2414 PRINT TAB(44);
2420 PRINT USING"###.###";C(I)*100
2430 LOCATE (5+I),63:PRINT USING"###.###";YY(I)
2440 NEXT I
2450 LOCATE 22,32:INPUT"Hard copy (y/n): ",HHH$
2451 IF HHH$="y" OR HHH$="Y" GOTO 2500
2452 IF HHH$="n" OR HHH$="N" GOTO 2900
2500 CLS:LOCATE 13,22
2510 INPUT"Please type sample name: ",SX$
2520 IF UU$="E" OR UU$="e" GOTO 2540
2530 IF UU$="O" OR UU$="o" GOTO 2670
2540 LPRINT:LPRINT:LPRINT:LPRINT
2541 LPRINT CHR$(27)+"G";
2550 LPRINT TAB(14)"Standardless Quantitative Microanalysis"
2557 LPRINT CHR$(27)+"H";
2560 LPRINT:LPRINT
2562 LPRINT TAB(30)"  Date: ";DATE$
2564 LPRINT TAB(30)"  Time: ";TIME$
2570 LPRINT TAB(30)"Sample: ";SX$
2580 LPRINT:LPRINT
2590 LPRINT TAB(16)"Accelerating voltage: ";E0;" keV"
2600 LPRINT TAB(16)"  Number of elements: ";A
2610 LPRINT:LPRINT
2620 LPRINT TAB(10)"Element";TAB(19)"Line";TAB(28)"Int";TAB(35)"Weight %";TAB(46)"Atomic %"
2630 LPRINT
2640 FOR I=1 TO A
2641 LPRINT TAB(12)"";Z$(I);TAB(20)"";T$(I);TAB(23);
2642 LPRINT USING"######.###";N(I);
2644 LPRINT TAB(35);
2647 LPRINT USING"###.###";C(I)*100;
2649 LPRINT TAB(46);
2650 LPRINT USING"###.###";(GG(I)*100)/ZZ
2655 NEXT I
2660 GOTO 2900
2670 LPRINT:LPRINT:LPRINT:LPRINT
2674 LPRINT CHR$(27)+"G";
2675 LPRINT TAB(14)"Standardless Quantitative Microanalysis"
2676 LPRINT CHR$(27)+"H";
2680 LPRINT:LPRINT
2682 LPRINT TAB(30)"  Date: ";DATE$
2683 LPRINT TAB(30)"  Time: ";TIME$
2690 LPRINT TAB(30)"Sample: ";SX$
2700 LPRINT:LPRINT
2710 LPRINT TAB(16)"Accelerating voltage: ";E0;" keV"
2720 LPRINT TAB(16)"  Number of elements: ";A
2730 LPRINT:LPRINT
2740 LPRINT TAB(10)"Element";TAB(19)"Line";TAB(28)"Int";TAB(36)"Weight %";TAB(47)"Weight % oxide"
2750 LPRINT
2760 FOR I=1 TO A
2770 LPRINT TAB(12)"";Z$(I);TAB(20)"";T$(I);TAB(23);
2771 LPRINT USING"######.###";N(I);
2772 LPRINT TAB(36);
2775 LPRINT USING"###.###";C(I)*100;
2777 LPRINT TAB(48);
2780 LPRINT USING"###.###";YY(I)
2790 NEXT I
2800 LPRINT:LPRINT
2900 close
2910 cls
2920 kill "data.dat"
2930 kill "elem.dat"
2940 kill "line.dat"
2950 kill "cps.dat"
2960 end
