30 'Standardless quantitative analysis via ZAF program
60 'Author:Henrik Kaker,Dec-1987
64 CLEAR
65 KEY OFF:color 7,0,0
80 OPEN"i",#2,"spt.dat"
81 INPUT #2,T20:T20=T20*.0001
82 INPUT #2,T21:T21=T21*.0001
83 INPUT #2,T22:T22=T22*.0001
84 INPUT #2,T23:close
90 CLS
91 DIM A(3,3),B(3,9),C(16),D(16),E(16),F(16),G(3),H(2,2),K(16),L(16),M(16)
92 DIM P(2,3),R(16),S(16),U(4),V(2,10),W(12),X(92),Z(16)
93 DIM Z$(16),L$(16),A5(16),A6(16),AA(16),EE(16),UU(16),MM(16),OO(16),RR(16)
94 DIM UU1(15),EK(15),TX(15),FF(15),PP(15),SS(15),LL(15)
95 DIM XY(16),YY(16),CD(16),TH(16),M100(16),M200(16),M300(16)
96 DIM XX99(15),YY99(15),ZZ99(15)
97 T$="Quantitative Standardless Analysis"
98 locate 5,(80-len(T$))/2:print t$
99 locate 9,22
100 input"File name (without *.dat) : ",f$
104 'file transformations
106 OPEN"i",#1,f$+".dat"
107 I=0
108 WHILE NOT EOF(1)
109 INPUT #1,A$
110 I=I+1
111 WEND
112 CLOSE #1
113 OPEN"i",#2,f$+".dat"
114 OPEN"o",#3,"data.dat"
115 I=0
116 WHILE NOT EOF(2)
117 INPUT #2,A$
118 IF I>=5 THEN PRINT #3,A$
119 I=I+1
120 WEND
121 CLOSE
122 OPEN"i",#4,"data.dat"
123 N=0
124 WHILE NOT EOF(4)
125 INPUT #4,A$
126 N=N+1
127 WEND
128 CLOSE #4
129 OPEN"i",#5,"data.dat"
130 OPEN"o",#6,"elem.dat"
131 FOR I=1 TO N
132 INPUT #5,A$
133 A$=LEFT$(A$,2)
134 PRINT #6,A$
135 NEXT I
136 CLOSE
137 OPEN"i",#7,"data.dat"
138 OPEN"o",#8,"line.dat"
139 FOR I=1 TO N
140 INPUT #7,A$
141 A$=LEFT$(A$,6)
142 B$=RIGHT$(A$,3)
143 PRINT #8,B$
144 NEXT I
145 CLOSE
146 OPEN"i",#9,"data.dat"
147 OPEN"o",#10,"cps.dat"
148 FOR I=1 TO N
149 INPUT #9,A$
150 A$=RIGHT$(A$,15)
151 PRINT #10,A$
152 NEXT I
153 CLOSE
160 X9=0
161 DEF FNE(Y)=Y^1.66667
162 DEF FNF(Y)=1+Y+.05*Y*Y
163 LOCATE 9,23
164 OPEN"i",#3,"Cond.dat"
165 INPUT #3,V
167 INPUT #3,TT1:T1=.0174533*T1
168 INPUT #3,DD:D=.0174533*DD
169 INPUT #3,BCF
170 OPEN"i",#4,"elem.dat"
180 AAA=0
182 WHILE NOT EOF(4)
184 INPUT #4,XYS$
185 AAA=AAA+1
186 WEND
190 CLOSE
240 LOCATE 13,23
250 INPUT"Elements or oxides (e/o) : ",UU$
260 IF UU$="E" OR UU$="e" GOTO 280
270 IF UU$="O" OR UU$="o" GOTO 470
280 OPEN"i",#5,"elem.dat"
282 OPEN"i",#6,"line.dat"
284 OPEN"i",#7,"cps.dat"
290 FOR N1=1 TO AAA
300 INPUT #5,Z$(N1)
301 IF Z$(N1)="C" THEN Z(N1)=6
302 IF Z$(N1)="N" THEN Z(N1)=7
303 IF Z$(N1)="O" THEN Z(N1)=8
304 IF Z$(N1)="F" THEN Z(N1)=9
305 IF Z$(N1)="NA" THEN Z(N1)=11
306 IF Z$(N1)="MG" THEN Z(N1)=12
307 IF Z$(N1)="SI" THEN Z(N1)=14
308 IF Z$(N1)="S" THEN Z(N1)=16
309 IF Z$(N1)="CL" THEN Z(N1)=17
310 IF Z$(N1)="K" THEN Z(N1)=19
311 IF Z$(N1)="CA" THEN Z(N1)=20
312 IF Z$(N1)="SC" THEN Z(N1)=21
313 IF Z$(N1)="TI" THEN Z(N1)=22
314 IF Z$(N1)="V" THEN Z(N1)=23
315 IF Z$(N1)="CR" THEN Z(N1)=24
316 IF Z$(N1)="MN" THEN Z(N1)=25
317 IF Z$(N1)="FE" THEN Z(N1)=26
318 IF Z$(N1)="CO" THEN Z(N1)=27
319 IF Z$(N1)="NI" THEN Z(N1)=28
320 IF Z$(N1)="CU" THEN Z(N1)=29
321 IF Z$(N1)="ZN" THEN Z(N1)=30
322 IF Z$(N1)="GA" THEN Z(N1)=31
323 IF Z$(N1)="GE" THEN Z(N1)=32
324 IF Z$(N1)="AS" THEN Z(N1)=33
325 IF Z$(N1)="SE" THEN Z(N1)=34
326 IF Z$(N1)="BR" THEN Z(N1)=35
327 IF Z$(N1)="Rb" THEN Z(N1)=37
328 IF Z$(N1)="SR" THEN Z(N1)=38
329 IF Z$(N1)="Y" THEN Z(N1)=39
330 IF Z$(N1)="ZR" THEN Z(N1)=40
331 IF Z$(N1)="NB" THEN Z(N1)=41
332 IF Z$(N1)="MO" THEN Z(N1)=42
333 IF Z$(N1)="TC" THEN Z(N1)=43
334 IF Z$(N1)="RU" THEN Z(N1)=44
335 IF Z$(N1)="RH" THEN Z(N1)=45
336 IF Z$(N1)="PD" THEN Z(N1)=46
337 IF Z$(N1)="AG" THEN Z(N1)=47
338 IF Z$(N1)="CD" THEN Z(N1)=48
339 IF Z$(N1)="IN" THEN Z(N1)=49
340 IF Z$(N1)="SN" THEN Z(N1)=50
341 IF Z$(N1)="SB" THEN Z(N1)=51
342 IF Z$(N1)="TE" THEN Z(N1)=52
343 IF Z$(N1)="I" THEN Z(N1)=53
344 IF Z$(N1)="CS" THEN Z(N1)=55
345 IF Z$(N1)="BA" THEN Z(N1)=56
346 IF Z$(N1)="LA" THEN Z(N1)=57
347 IF Z$(N1)="CE" THEN Z(N1)=58
348 IF Z$(N1)="PR" THEN Z(N1)=59
349 IF Z$(N1)="ND" THEN Z(N1)=60
350 IF Z$(N1)="PM" THEN Z(N1)=61
351 IF Z$(N1)="AL" THEN Z(N1)=13
352 IF Z$(N1)="SM" THEN Z(N1)=62
353 IF Z$(N1)="EU" THEN Z(N1)=63
354 IF Z$(N1)="GD" THEN Z(N1)=64
355 IF Z$(N1)="TB" THEN Z(N1)=65
356 IF Z$(N1)="DY" THEN Z(N1)=66
357 IF Z$(N1)="HO" THEN Z(N1)=67
358 IF Z$(N1)="ER" THEN Z(N1)=68
359 IF Z$(N1)="TM" THEN Z(N1)=69
360 IF Z$(N1)="YB" THEN Z(N1)=70
361 IF Z$(N1)="LU" THEN Z(N1)=71
362 IF Z$(N1)="HF" THEN Z(N1)=72
363 IF Z$(N1)="TA" THEN Z(N1)=73
364 IF Z$(N1)="W" THEN Z(N1)=74
365 IF Z$(N1)="RE" THEN Z(N1)=75
366 IF Z$(N1)="OS" THEN Z(N1)=76
367 IF Z$(N1)="IR" THEN Z(N1)=77
368 IF Z$(N1)="PT" THEN Z(N1)=78
369 IF Z$(N1)="AU" THEN Z(N1)=79
370 IF Z$(N1)="HG" THEN Z(N1)=80
371 IF Z$(N1)="TL" THEN Z(N1)=81
372 IF Z$(N1)="PB" THEN Z(N1)=82
373 IF Z$(N1)="BI" THEN Z(N1)=83
374 IF Z$(N1)="U" THEN Z(N1)=92
375 IF Z$(N1)="P" THEN Z(N1)=15
380 INPUT #6,L$(N1)
390 L(N1)=0
400 IF L$(N1)="K  " THEN L(N1)=1
410 IF L$(N1)="L  " THEN L(N1)=2
420 IF L$(N1)="M  " THEN L(N1)=3
430 IF L$(N1)="O  " THEN L(N1)=0
440 INPUT #7,A5(N1)
450 NEXT N1
455 CLOSE #5,#6,#7
460 GOTO 700
470 CLS
471 OPEN"i",#5,"elem.dat"
472 OPEN"i",#6,"line.dat"
473 OPEN"i",#7,"cps.dat"
475 LOCATE 3,18
480 PRINT TAB(18)"Element";TAB(28)"Line";TAB(38)"Int";TAB(48)"Stehiom.ratio"
490 FOR N1=1 TO AAA
500 LOCATE (4+N1),21:INPUT #5,Z$(N1):PRINT Z$(N1)
510 IF Z$(N1)="C" THEN Z(N1)=6
511 IF Z$(N1)="N" THEN Z(N1)=7
512 IF Z$(N1)="O" THEN Z(N1)=8
513 IF Z$(N1)="F" THEN Z(N1)=9
514 IF Z$(N1)="NA" THEN Z(N1)=11
515 IF Z$(N1)="AL" THEN Z(N1)=13
516 IF Z$(N1)="SI" THEN Z(N1)=14
517 IF Z$(N1)="P" THEN Z(N1)=15
518 IF Z$(N1)="S" THEN Z(N1)=16
519 IF Z$(N1)="CL" THEN Z(N1)=17
520 IF Z$(N1)="K" THEN Z(N1)=19
521 IF Z$(N1)="CA" THEN Z(N1)=20
522 IF Z$(N1)="SC" THEN Z(N1)=21
523 IF Z$(N1)="TI" THEN Z(N1)=22
524 IF Z$(N1)="V" THEN Z(N1)=23
525 IF Z$(N1)="CR" THEN Z(N1)=24
526 IF Z$(N1)="MN" THEN Z(N1)=25
527 IF Z$(N1)="FE" THEN Z(N1)=26
528 IF Z$(N1)="CO" THEN Z(N1)=27
529 IF Z$(N1)="NI" THEN Z(N1)=28
530 IF Z$(N1)="CU" THEN Z(N1)=29
531 IF Z$(N1)="ZN" THEN Z(N1)=30
532 IF Z$(N1)="MG" THEN Z(N1)=12
533 IF Z$(N1)="GA" THEN Z(N1)=31
534 IF Z$(N1)="GE" THEN Z(N1)=32
535 IF Z$(N1)="AS" THEN Z(N1)=33
536 IF Z$(N1)="SE" THEN Z(N1)=34
537 IF Z$(N1)="BR" THEN Z(N1)=35
538 IF Z$(N1)="RB" THEN Z(N1)=37
539 IF Z$(N1)="SR" THEN Z(N1)=38
540 IF Z$(N1)="Y" THEN Z(N1)=39
541 IF Z$(N1)="ZR" THEN Z(N1)=40
542 IF Z$(N1)="NB" THEN Z(N1)=41
543 IF Z$(N1)="MO" THEN Z(N1)=42
544 IF Z$(N1)="TC" THEN Z(N1)=43
545 IF Z$(N1)="RU" THEN Z(N1)=44
546 IF Z$(N1)="RH" THEN Z(N1)=45
547 IF Z$(N1)="PD" THEN Z(N1)=46
548 IF Z$(N1)="AG" THEN Z(N1)=47
549 IF Z$(N1)="CD" THEN Z(N1)=48
550 IF Z$(N1)="IN" THEN Z(N1)=49
551 IF Z$(N1)="SN" THEN Z(N1)=50
552 IF Z$(N1)="SB" THEN Z(N1)=51
553 IF Z$(N1)="TE" THEN Z(N1)=52
554 IF Z$(N1)="I" THEN Z(N1)=53
555 IF Z$(N1)="CS" THEN Z(N1)=55
556 IF Z$(N1)="BA" THEN Z(N1)=56
557 IF Z$(N1)="LA" THEN Z(N1)=57
558 IF Z$(N1)="CE" THEN Z(N1)=58
559 IF Z$(N1)="PR" THEN Z(N1)=59
560 IF Z$(N1)="PM" THEN Z(N1)=61
561 IF Z$(N1)="ND" THEN Z(N1)=60
562 IF Z$(N1)="SM" THEN Z(N1)=62
563 IF Z$(N1)="EU" THEN Z(N1)=63
564 IF Z$(N1)="GD" THEN Z(N1)=64
565 IF Z$(N1)="TB" THEN Z(N1)=65
566 IF Z$(N1)="DY" THEN Z(N1)=66
567 IF Z$(N1)="HO" THEN Z(N1)=67
568 IF Z$(N1)="ER" THEN Z(N1)=68
569 IF Z$(N1)="TM" THEN Z(N1)=69
570 IF Z$(N1)="YB" THEN Z(N1)=70
571 IF Z$(N1)="LU" THEN Z(N1)=71
572 IF Z$(N1)="HF" THEN Z(N1)=72
573 IF Z$(N1)="TA" THEN Z(N1)=73
574 IF Z$(N1)="W" THEN Z(N1)=74
575 IF Z$(N1)="RE" THEN Z(N1)=75
576 IF Z$(N1)="OS" THEN Z(N1)=76
577 IF Z$(N1)="IR" THEN Z(N1)=77
578 IF Z$(N1)="PT" THEN Z(N1)=78
579 IF Z$(N1)="AU" THEN Z(N1)=79
580 IF Z$(N1)="HG" THEN Z(N1)=80
581 IF Z$(N1)="TL" THEN Z(N1)=81
582 IF Z$(N1)="PB" THEN Z(N1)=82
583 IF Z$(N1)="BI" THEN Z(N1)=83
584 IF Z$(N1)="U" THEN Z(N1)=92
589 L(N1)=0
590 LOCATE (4+N1),29:INPUT #6,L$(N1):PRINT L$(N1)
600 IF L$(N1)="K  " THEN L(N1)=1
610 IF L$(N1)="L  " THEN L(N1)=2
620 IF L$(N1)="M  " THEN L(N1)=3
630 IF L$(N1)="O  " THEN L(N1)=0
640 LOCATE (4+N1),34:INPUT #7,A5(N1):PRINT USING"######.###";A5(N1)
650 LOCATE (4+N1),53:INPUT"",A6(N1)
660 NEXT N1
670 CLOSE
700 'k-ratio calc.
710 FOR N1=1 TO AAA
720 AA(N1)=-1.42+1.97*Z(N1)+.0103*Z(N1)^2-.0000429*Z(N1)^3
730 IF L(N1)=1 THEN EE(N1)=5.706779E-03*Z(N1)^2.186
740 IF L(N1)=2 THEN EE(N1)=2.01587E-04*Z(N1)^2.5183
750 IF L(N1)=3 THEN EE(N1)=2.8537E-06*Z(N1)^3.11494
760 UU(N1)=V/EE(N1)
770 IF L(N1)=1 THEN MM(N1)=294477!*Z(N1)^(-2.56464)
780 IF L(N1)=2 THEN MM(N1)=1.90666E+07*Z(N1)^(-2.72348)
790 IF L(N1)=3 THEN MM(N1)=7.228677E+09*Z(N1)^(-3.58163)
800 IF L(N1)=1 THEN OO(N1)=(1*Z(N1)^4)/(1150000!+Z(N1)^4)
810 IF L(N1)=2 THEN OO(N1)=(3.555*Z(N1)^4)/(1.02E+08+Z(N1)^4)
820 IF L(N1)=3 THEN OO(N1)=(4.361*Z(N1)^4)/(7.5E+08+Z(N1)^4)
830 RR(N1)=(EXP(-.004*Z(N1)*(UU(N1)-1)^.3))*COS(.56*T1)
840 RR(N1)=RR(N1)*EXP((LOG(.0753/UU(N1)+.8994)*((1/COS(T1))-1-T1/90)))
850 UU1(N1)=(UU(N1)-1)^(5/3)
860 IF L(N1)=1 THEN EK(N1)=EXP(-5.49184+2.54555*LOG(Z(N1))-.128429*(LOG(Z(N1)))^2+.0120661*(LOG(Z(N1)))^3)
870 IF L(N1)=2 THEN EK(N1)=EXP(-13.2015+5.92457*LOG(Z(N1))-.790156*(LOG(Z(N1)))^2+.0560193*(LOG(Z(N1)))^3)
880 IF L(N1)=3 THEN EK(N1)=EXP(6.66542-11.2046*LOG(Z(N1))+3.58209*(LOG(Z(N1)))^2-.303821*(LOG(Z(N1)))^3)
881 'efficiency calc.
882 IF EK(N1)=<1.487 THEN M100=.3102*(12.3981/EK(N1))^3.001
883 IF EK(N1)>1.487 THEN M100=2.4604*.111*(12.3981/EK(N1))^3.03
884 IF EK(N1)=<1.487 THEN M200=1.759*(12.3981/EK(N1))^2.706
885 IF EK(N1)>1.487 AND EK(N1)=<2.0147 THEN M200=9.130901*1.8389*(12.3981/EK(N1))^2.94
886 IF EK(N1)>2.0147 THEN M200=19.57*(12.3981/EK(N1))^2.7345
887 IF EK(N1)=<1.487 THEN M300=41.17*(12.3981/EK(N1))^1.906
888 IF EK(N1)>1.487 AND EK(N1)<=2.2057 THEN M300=19.4943*.7588*(12.3981/EK(N1))^2.393
889 IF EK(N1)>2.2057 AND EK(N1)<=2.2911 THEN M300=19.4943*2.2057*(12.3981/EK(N1))^2.2
890 IF EK(N1)>2.2911 AND EK(N1)<=2.743 THEN M300=19.4943*2.2911*(12.3981/EK(N1))^2.4
891 IF EK(N1)>2.743 AND EK(N1)<=3.1478 THEN M300=19.4943*2.743*(12.3981/EK(N1))^2.4471
892 IF EK(N1)>3.1478 AND EK(N1)<=3.4249 THEN M300=19.4943*3.1478*(12.3981/EK(N1))^2.4471
893 IF EK(N1)>3.4249 AND EK(N1)<=11.9187 THEN M300=19.4943*3.4249*(12.3981/EK(N1))^2.575
894 IF EK(N1)>11.9187 AND EK(N1)<=13.7336 THEN M300=19.4943*11.9187*(12.3981/EK(N1))^2.3554
895 IF EK(N1)>13.7336 AND EK(N1)<=14.3528 THEN M300=19.4943*13.7336*(12.3981/EK(N1))^2.61439
896 IF EK(N1)>14.3528 THEN M300=19.4943*14.3528*(12.3981/EK(N1))^2.65
900 TX(N1)=EXP(-M100*(T20/COS(D))*1.85-M200*(T22/COS(D))*2.329-M300*(T21/COS(D))*19.3)*(1-EXP(-M200*(T23/COS(D))*2.329))
916 FF(N1)=1/(1+.0000013*MM(N1)*(COS(T1)/SIN(D))*(V^1.65-EE(N1)^1.65))^2
917 IF L(N1)=1 THEN PP(N1)=UU1(N1)*OO(N1)*TX(N1)*RR(N1)*FF(N1)/AA(N1)
918 IF L(N1)=2 THEN PP(N1)=UU1(N1)*OO(N1)*TX(N1)*RR(N1)*FF(N1)/AA(N1)
919 IF L(N1)=3 THEN PP(N1)=UU1(N1)*OO(N1)*TX(N1)*RR(N1)*FF(N1)/AA(N1)
920 NEXT N1
935 FOR N1=1 TO AAA
940 SS(N1)=A5(N1)/PP(N1)
942 NEXT N1
944 SS1=0
946 FOR N1=1 TO AAA
948 SS1=SS1+SS(N1)
950 NEXT N1
952 FOR N1=1 TO AAA
954 K(N1)=SS(N1)/SS1
956 NEXT N1
1000 FOR N1=1 TO AAA:AA(N1)=0:EE(N1)=0:UU(N1)=0:MM(N1)=0:OO(N1)=0:RR(N1)=0:UU1(N1)=0:EK(N1)=0:TX(N1)=0:PP(N1)=0:SS(N1)=0:NEXT N1
1001 T20=0:T21=0:T22=0:T23=0:T1=0:D=0:SS1=0
1060 '   ***define variables and read in constants ****
1070 '   ***A(3,3) are data for Ka,La,Ma energy calc.***
1080 FOR I=1 TO 3
1090 FOR J=1 TO 3
1100 READ A(J,I)
1110 NEXT J
1120 NEXT I
1130 DATA -1.8860E-2,2.21859,-5.17083
1140 DATA -.123941,3.29533,-9.75836
1150 DATA -.47555,6.84662,-20.0833
1160 '   ***B(3,9) are data for abs.edge calc.***
1170 FOR I=1 TO 9
1180 FOR J=1 TO 3
1190 READ B(J,I)
1200 NEXT J
1210 NEXT I
1220 DATA -3.97391E-2,2.423,5.5091
1230 DATA -.033916,2.82526,9.03526
1240 DATA -8.65397E-2,3.32315,10.2505
1250 DATA -.228343,4.31172,12.0025
1260 DATA 1.25179,-7.838,-11.5803
1270 DATA .834903,-4.14925,-3.33802
1280 DATA .442217,-.979241,3.15348
1290 DATA .25141,.931913,8.03561
1300 DATA .272951,.688906,7.4243
1310 '   ***C(8) are concentrations of elements***
1320 '   ***D(8) is geometry factor***
1330 '   ***E(8) are emission line energies of elements***
1340 '   ***F(8) are absorption edge energies of elements***
1350 '   ***G(3) are abs edge jump ratios***
1360 FOR I=1 TO 3
1370 READ G(I)
1380 NEXT I
1390 DATA .88,.75,.5
1400 '   ***H(2,2) used in fluor.calc.***
1410 FOR I=1 TO 2
1420 FOR J=1 TO 2
1430 READ H(J,I)
1440 NEXT J
1450 NEXT I
1460 DATA 2.373,-8.902
1470 DATA 2.946,-13.94
1480 '   ***I is index of element being calculated***
1490 '   ***J is index of matrix elements**
1500 '   ***K(8) are normalized intensities***
1510 '   ***L(8) are lines analyzed 1=K,2=L,3=M,0=by diff.***
1520 '   ***M(8) are used for abs.coeff.***
1530 '   ***N1=total no.elem.,N2=no.analyzed,N3=# iteration***
1540 '   ***P(2,3)=factors for interline fluorescence***
1550 FOR I=1 TO 2
1560 FOR J=1 TO 3
1570 READ P(I,J)
1580 NEXT J
1590 NEXT I
1600 DATA 1,.24,.02
1610 DATA 4.2,1,.02
1620 '   ***Q1 is partial concentration sum***
1630 '   ***R(8) are used for back scatter factors***
1640 '   ***S(8) are used for stopping powers***
1650 '   ***T0,T1,...,T9 are temporary scratchpad***
1660 '   ***U(4) are exponents in mass.abs.coefficients***
1670 '   ***V(2,10) are data for mass.abs.coefficients***
1680 FOR I=1 TO 2
1690 FOR J=1 TO 10
1700 READ V(I,J)
1710 NEXT J
1720 NEXT I
1730 DATA 1,1,1.17,1.63,1,1.16,1.4,1.621,1.783,1
1740 DATA 1,2,2,2,3,3,3,3,3,4
1750 '   *** W(12)=data for mass.abs coeff. calc.***
1760 FOR I=1 TO 12
1770 READ W(I)
1780 NEXT I
1790 DATA -.232229,-.254471,.256216,1.35917
1800 DATA 4.07005,4.76925,1.15119,-9.49212
1810 DATA -6.22075,-10.3788,-5.68485,18.6408
1820 REM ***X(92) ARE ATOMIC WEIGHTS***
1830 FOR I=1 TO 92
1840 READ X(I)
1850 NEXT I
1860 DATA 1.008,4.004,6.94,9.013,10.82,12.011
1870 DATA 14.007,16,19,20.18,22.99,24.31
1880 DATA 26.98,28.09,30.97,32.06,35.45,39.95
1890 DATA 39.1,40.08,44.96,47.9,50.94,52
1900 DATA 54.94,55.85,58.93,58.71,63.54,65.37
1910 DATA 69.72,72.59,74.92,78.96,79.91,83.8
1920 DATA 85.47,87.62,88.91,91.22,92.91,95.94
1930 DATA 99,101.1,102.9,106.4,107.9,112.4
1940 DATA 114.8,118.7,121.8,127.6,126.9,131.3
1950 DATA 132.9,137.3,138.9,140.1,140.9,144.2
1960 DATA 145,150.4,152,157.2,158.9,162.5
1970 DATA 164.9,167.3,168.9,173,175,178.5
1980 DATA 180.95,183.85,186.2,190.2,192.2,195.1
1990 DATA 196.97,200.6,204.4,207.2,209,210
2000 DATA 210,222,223,226,227,232,231,238
2010 '   ***Y is fluorescence correction***
2020 '   ***Z(8) are At.No.'s of elements***
2150 D=COS(.0174533*TT1)/SIN(.0174533*DD)
2160 IF X9=1 GOTO 3510
2290 N1=N1-1
2300 N2=N1
2310 GOTO 2330
2320 N2=N1-1
2330 N3=1
2340 Q=0
2350 '   ***calculation energies***
2360 FOR I=1 TO N2
2370 Z=LOG(Z(I))
2380 T2=L(I)*L(I)
2390 E(I)=EXP(A(1,L(I))*Z*Z+A(2,L(I))*Z+A(3,L(I)))
2400 F(I)=EXP(B(1,T2)*Z*Z+B(2,T2)*Z-B(3,T2))
2410 C(I)=K(I)
2420 Q=Q+C(I)
2430 NEXT I
2440 IF N1=N2 THEN GOTO 2490
2450 IF Q<=1 GOTO 2470
2460 Q=.99
2470 K(N1)=1-Q
2480 C(N1)=K(N1)
2490 Q=0
2500 '   ***calculation Z correction***
2510 FOR I=1 TO N2
2520 FOR J=1 TO N1
2530 T6=V/F(I)
2533 IF T6<10 GOTO 2540
2536 T6=10
2540 T7=.00873*T6^3-.1669*T6^2+.9662*T6+.4523
2550 T8=.002703*T6^3-.05182*T6^2+.302*T6-.1836
2560 T9=.887-3.44/T6+9.33/T6^2-6.43/T6^3
2570 R(J)=T7-T8*LOG(T9*Z(J)+25)
2580 T2=9.76*Z(J)+58.5*Z(J)^(-.19)
2590 S(J)=2*Z(J)/X(Z(J))/(V+F(I))*LOG(583*(V+F(I))/T2)
2600 E=E(I)
2610 Z=Z(J)
2620 GOSUB 3310
2630 M(J)=T3
2640 NEXT J
2650 '   *** calculation Absorption correction***
2660 T2=.000003*(FNE(V)-FNE(F(I)))
2670 T3=T2*M(I)*D
2680 T3=FNF(T3)
2690 T4=T3
2700 T7=0
2710 T8=0
2720 T9=0
2730 FOR J=1 TO N1
2740 T7=T7+C(J)*S(J)
2750 T8=T8+C(J)*R(J)
2760 T9=T9+C(J)*M(J)
2770 NEXT J
2780 T3=T2*T9*D
2790 T3=FNF(T3)
2800 '   ***combine Z & A correction***
2810 T2=R(I)*T3*T7/S(I)/T8/T4
2820 '   *** calculation F correction***
2822 XX99(I)=S(I)*T8/R(I)/T7
2823 YY99(I)=T4/T3
2830 Y=0
2840 FOR J=1 TO N1
2850 Z=LOG(Z(J))
2860 T4=1
2870 E=EXP(A(1,T4)*Z*Z+A(2,T4)*Z+A(3,T4))
2880 IF E<F(I) GOTO 3480
2890 IF E>F(I)+5 THEN 3480
2900 T7=.5*EXP(H(1,T4)*LOG(Z(J))+H(2,T4))
2910 T8=0
2920 FOR T6=1 TO N1
2930 Z=Z(T6)
2940 GOSUB 3310
2950 T8=T8+T3*C(T6)
2960 NEXT T6
2970 T6=T9*D/T8
2980 T5=333000!/(FNE(V)-FNE(F(I)))/T8
2990 T6=LOG(1+T6)/T6+LOG(1+T5)/T5
3000 Z=Z(I)
3010 GOSUB 3310
3020 Z=LOG(Z(J))
3030 E=EXP(B(1,T4*T4)*Z*Z+B(2,T4*T4)*Z-B(3,T4*T4))
3040 T5=FNE((V/E-1)/(V/F(I)-1))*P(T4,L(I))*G(L(I))
3050 Y=Y+C(J)*T7*T5*T3*T6*X(Z(I))/X(Z(J))/T8
3060 NEXT J
3070 '   ***calc.conc.&next aprrox.***
3080 T2=C(I)/T2*(1+Y)
3083 ZZ99(I)=(1+Y)
3085 IF X9= 1 GOTO 3530
3090 C(I)=(K(I)*C(I)*(1-T2))/(K(I)*(C(I)-T2)+T2*(1-C(I)))
3100 Q=Q+C(I)
3110 NEXT I
3115 IF X9=1 GOTO 3550
3120 IF N1=N2 THEN GOTO 3180
3130 IF Q<=1 GOTO 3160
3140 C(N1)=0
3150 GOTO 3180
3160 C(N1)=(1-Q)
3170 Q=1
3180 IF N3=3 THEN 3240
3190 N3=N3+1
3200 FOR I=1 TO N1
3210 C(I)=C(I)/Q
3220 NEXT I
3230 GOTO 2490
3240 PRINT
3250 CLS
3252 LOCATE 3,10
3253 IF UU$="E" OR UU$="e" GOTO 3254 ELSE 3279
3254 PRINT TAB(5)"Element";TAB(14)"Line";TAB(20)"K-ratio";TAB(30)"[Z]";TAB(37)"[A]";TAB(44)"[F]";TAB(50)"[ZAF]";TAB(60)"Weight %";TAB(70)"Atomic %"
3256 FOR I=1 TO N1:YY(I)=-1.42+1.97*Z(I)+.0103*Z(I)^2-.0000429*Z(I)^3:XY(I)=(C(I)*100)/YY(I):NEXT I
3258 XY1=0:FOR I=1 TO N1:XY1=XY1+XY(I):NEXT I
3260 FOR I=1 TO N1
3261 LOCATE (5+I),7:PRINT"";Z$(I);TAB(15);L$(I);TAB(21);
3262 PRINT USING"#.###";K(I)
3263 LOCATE (5+I),29:PRINT USING"#.###";XX99(I)
3264 LOCATE (5+I),36:PRINT USING"#.###";YY99(I)
3265 LOCATE (5+I),43:PRINT USING"#.###";ZZ99(I)
3266 LOCATE (5+I),50:PRINT USING"#.###";(XX99(I)*YY99(I)*ZZ99(I))
3275 LOCATE (5+I),60:PRINT USING"###.###";C(I)*100
3277 LOCATE (5+I),70:PRINT USING"###.###";(XY(I)*100)/XY1
3278 NEXT I:GOTO 3291
3279 FOR I=1 TO N1:YY(I)=-1.42+1.97*Z(I)+.0103*Z(I)^2-.0000429*Z(I)^3:NEXT I:ZZ=0:FOR I=1 TO N1:CD(I)=(C(I)*100)*(YY(I)+A6(I)*15.9994)/YY(I):ZZ=ZZ+CD(I):NEXT I:FOR I=1 TO N1:TH(I)=(CD(I)*100)/ZZ:NEXT I
3280 PRINT TAB(5)"Element";TAB(14)"Line";TAB(20)"K-ratio";TAB(30)"[Z]";TAB(37)"[A]";TAB(44)"[F]";TAB(50)"[ZAF]";TAB(60)"Weight %";TAB(70)"Atomic %"
3281 FOR I=1 TO N1
3282 LOCATE (5+I),7:PRINT"";Z$(I);TAB(15);L$(I);TAB(21);
3283 PRINT USING"#.###";K(I)
3284 LOCATE (5+I),29:PRINT USING"#.###";XX99(I)
3285 LOCATE (5+I),36:PRINT USING"#.###";YY99(I)
3286 LOCATE (5+I),43:PRINT USING"#.###";ZZ99(I)
3287 LOCATE (5+I),50:PRINT USING"#.###";(XX99(I)*YY99(I)*ZZ99(I))
3288 LOCATE (5+I),60:PRINT USING"###.###";C(I)*100
3289 LOCATE (5+I),70:PRINT USING"###.###";TH(I)
3290 NEXT I
3291 GOTO 3600
3300 '   ***subroutine for abs.coeff.energy E in elem. Z***
3310 T3=LOG(Z)
3320 U(1)=EXP(-.0045522*T3*T3-.0068535*T3+1.07018)
3330 U(2)=2.73
3340 U(3)=2.6
3350 U(4)=2.22
3360 IF Z<42 THEN 3380
3370 U(2)=EXP(-.113159*T3*T3+.836883*T3-.545969)
3380 T1=1
3390 IF T1=10 THEN 3420
3400 T0=EXP(B(1,T1)*T3*T3+B(2,T1)*T3-B(3,T1))
3410 IF E<T0 GOTO 3460
3420 T0=W(V(2,T1))*T3*T3+W(V(2,T1)+4)*T3+W(V(2,T1)+8)
3430 T0=EXP(T0)/V(1,T1)
3440 T3=T0*(12.398/E)^U(V(2,T1))
3450 RETURN
3460 T1=T1+1
3470 GOTO 3390
3480 IF T4=2 THEN 3060
3490 T4=2
3500 GOTO 2870
3510 LOCATE 13,10
3515 IF UU$="E" OR UU$="e" OR UU$="O" OR UU$="o" GOTO 3516
3516 PRINT TAB(21)"Element";TAB(38)"Line";TAB(52)"Weight %"
3520 GOTO 2160
3530 K(I)=T2
3540 GOTO 3110
3550 PRINT
3560 CLS:LOCATE 3,18:PRINT TAB(20)"Element";TAB(35)"Line";TAB(50)"K-ratio"
3570 FOR I=1 TO N1
3580 LOCATE (4+I),23:PRINT"";Z$(I);TAB(36)"";L$(I);TAB(51);
3585 PRINT USING"#.###";K(I)
3590 NEXT I
3600 '   line printer
3640 LOCATE 24,30
3650 INPUT"Hard copy (y/n): ",AB$
3660 IF AB$="N" OR AB$="n" GOTO 5000
3670 IF AB$="Y" OR AB$="y" GOTO 3680
3680 CLS:LOCATE 13,22
3690 INPUT"Please type sample name: ",SX$
3720 LPRINT:LPRINT:LPRINT:LPRINT
3725 LPRINT CHR$(27)+"G";
3730 LPRINT TAB(22)"Quantitative No-Standards Analysis"
3731 LPRINT CHR$(27)+"H"
3740 LPRINT:LPRINT
3741 LPRINT TAB(30)"  Date: ";DATE$
3742 LPRINT TAB(30)"  Time: ";TIME$
3750 LPRINT TAB(30)"Sample: ";SX$
3760 LPRINT:LPRINT
3780 LPRINT TAB(16)"Accelerating voltage: ";V;" keV"
3790 LPRINT TAB(16)"          Tilt angle: ";TT1;" degrees"
3800 LPRINT TAB(16)"      Take-off angle: ";DD;" degrees"
3810 LPRINT TAB(16)"  Number of elements: ";AAA
3820 LPRINT:LPRINT
3825 IF UU$="E" OR UU$="e" GOTO 3830 ELSE 3900
3830 LPRINT TAB(10)"Element";TAB(19)"Line";TAB(27)"Int";TAB(34)"K-ratio";TAB(44)"Weight %";TAB(55)"Atomic %"
3840 LPRINT
3850 FOR I=1 TO N1
3860 LPRINT TAB(12)"";Z$(I);TAB(20)"";L$(I);TAB(23);
3861 LPRINT USING"######.###";A5(I);
3862 LPRINT TAB(36);
3870 LPRINT USING"#.###";K(I);
3871 LPRINT TAB(45);
3872 LPRINT USING"###.###";C(I)*100;
3873 LPRINT TAB(56);
3874 LPRINT USING"###.###";(XY(I)*100)/XY1
3880 NEXT I
3890 LPRINT:LPRINT:GOTO 5000
3900 LPRINT TAB(10)"Element";TAB(19)"Line";TAB(27)"Int";TAB(34)"K-ratio";TAB(44)"Weight %";TAB(55)"Weight % oxide"
3910 LPRINT
3920 FOR I=1 TO N1
3930 LPRINT TAB(12)"";Z$(I);TAB(20)"";L$(I);TAB(23);
3931 LPRINT USING"######.###";A5(I);
3932 LPRINT TAB(36);
3940 LPRINT USING"#.###";K(I);
3941 LPRINT TAB(45);
3942 LPRINT USING"###.###";C(I)*100;
3943 LPRINT TAB(58);
3944 LPRINT USING"###.###";TH(I)
3950 NEXT I
5000 kill"data.dat"
5010 kill"elem.dat"
5020 kill"line.dat"
5030 kill"cps.dat"
5040 close
5050 cls
5060 end
